from IPython.core.display import Image, display 
import pydot
from . import Graph 
embed_image = lambda img  :Image(filename=img)



def dot_render(g1,value_formatter=None,node_formatter=None):

    label = g1.__label__

    if value_formatter is None:
        value_formatter = lambda v : v 

   
    if node_formatter is None:
        node_formatter= lambda k,v : "%s[label=\"%s\"]" % (k,value_formatter(v)  )

    #format_node = lambda k,v : "%s[label=\"%s\"]" % (k,value_formatter(v)  )
    #mapper= lambda k,v:  format_node(k,v)
    mapper= lambda k,v:  node_formatter(k,v)

    nodes = "\n".join( Graph.node_mapper(g1,mapper ))
    edges="\n".join([ "%s->%s" % (a,b) for a,b in g1.__edges__])
    dot_source = '''
    digraph {
        label=%s 
        %s 
        %s
    }


    '''
    return display_graph ("moo", dot_source %  (label, nodes,edges ) )



def dot_render2(g):
    line = "digraph {\n"
    labels =  list(g.__nodes__)
    nodes = [ "a%s" % n[0] for n in enumerate(list(g.__nodes__)) ]
    l_2_n = dict(zip(labels,nodes))
    for e in g.__edges__:
        a = l_2_n [ e[0] ] 
        b = l_2_n [ e[1]  ] 
        line = line +  "%s->%s;\n" % (a,b)
    for n in g.__nodes__:
        a = l_2_n [ n ] 
        line = line + "%s [ label=\"%s\" ]; \n" % (a,n)
    line = line + "}"
    #print line 
    display(display_graph(str(g.__label__),line))

def display_graph(label,dot_string):
    dot_graph = pydot.graph_from_dot_data(dot_string)
    dot_graph[0].label = label
    dot_graph[0].write_png("%s.png" % label)
    return embed_image("%s.png" % label )


